#!/Users/wijs/bin/pypy

# Read an MDP graph, and write an AUT file based on it (stripped of its probabilities), v.1.0 by Anton Wijs, 2014

import sys, string, collections, itertools, copy, math
import re

# command line options
opt_mdp = ""
opt_aut = ""

def print_error(s):
	"""Print message to screen and exit"""
	if not opt_quiet:
		print("ERROR: " + str(s))
	sys.exit(1)

def print_message(s):
	"""Print message to screen"""
	if not opt_quiet:
		print(s)

def MDP2AUT(mdpfile, autfile):
	"""Read a given MDP file, ignoring the probabilities attached to transitions, and write result to AUT file"""
	try:
		inFile = open(mdpfile,'r')
	except IOError:
		print_error("MDP graph file does not exist!")
		return {}
	outfile = open(autfile,'w')
	for line in inFile:
		words = line.split()
		if len(words) == 3:
			# this must be the header. store nr of states and transitions
			nstates = words[0]
			ntrans = words[2]
			# write header of aut file
			outfile.write("des (0, " + str(ntrans) + ", " + str(nstates) + ")\n")
		else:
			# store transition
			src = words[0]
			tgt = words[2]
			if len(words) == 5:
				act = words[4]
			else:
				act = 'i'
			# write transition
			outfile.write("(" + str(src) + ", " + str(act) + ", " + str(tgt) + ")\n")
	outfile.close()

if __name__ == '__main__':
#	parser = argparse.ArgumentParser()
#	parser.add_argument("-g", "--generate", action="store_true", help="generate the system LTS from a given network (extension .exp added)")
#	parser.add_argument("network", help="the name of a network of LTSs (without extension)")
#
#   args = parser.parse_args()
	for i in range(1,len(sys.argv)):
		if sys.argv[i] == '-h':
			print "Usage: mdp2aut inputfile outputfile"
			print ""
			print "Read a given MDP graph and write an AUT file based on it"
			print ""
		if i == 1:
			opt_mdp = sys.argv[i]
		elif i == len(sys.argv)-1:
			opt_aut = sys.argv[i]
	if opt_mdp == '':
		print "no MDP graph given!"
		exit(1)
	if opt_aut == '':
		print "no AUT given!"
		exit(1)
	print 'converting MDP graph'
	print '---'
	MDP2AUT(opt_mdp, opt_aut)
	print 'done!'
